// Loader.c     Loads/unloads the first vxd found in the directory
// 04/01/98     VV
#include    <windows.h>

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
                   LPSTR lpCmdLine, int nCmdShow)
{
    HANDLE hVxd; HANDLE hFile;
    char szDevPath[MAX_PATH]; char str[MAX_PATH];
    WIN32_FIND_DATA fileData;
    char szVxdWildcard[] = "*.vxd";
    char szLoadCaption[]="Load VxD";
	char szUnloadCaption[]="Unload VxD";
    
    // find a vxd and ask to load
    hFile = FindFirstFile(szVxdWildcard, &fileData);
    if (hFile == INVALID_HANDLE_VALUE) {
        MessageBox(NULL, "No VxD found", szLoadCaption, MB_ICONSTOP); 
        return 1;
    }
    CloseHandle(hFile);

    // load it
    wsprintf(szDevPath, "\\\\.\\%s", fileData.cFileName);
    hVxd =  CreateFile(szDevPath,GENERIC_READ, 0, NULL,
                OPEN_ALWAYS, FILE_FLAG_DELETE_ON_CLOSE, 0);

    if (hVxd == INVALID_HANDLE_VALUE) {
        wsprintf(str, "Failed to load %s", fileData.cFileName);
        MessageBox(NULL, str, szLoadCaption, MB_ICONSTOP); 
        return 1;
    }

    // wait for click to unload
    wsprintf(str, "%s is loaded. Click <OK> to unload it", 
				fileData.cFileName);
    MessageBox(NULL, str, szUnloadCaption, MB_OK); 
    CloseHandle(hVxd);
    return 0;
}