// scrnView.cpp : implementation of the CScrntestView class
//

#include "stdafx.h"
#include "scrntest.h"

#include "scrntDoc.h"
#include "scrnView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CScrntestView

IMPLEMENT_DYNCREATE(CScrntestView, CView)

BEGIN_MESSAGE_MAP(CScrntestView, CView)
	//{{AFX_MSG_MAP(CScrntestView)
	ON_WM_CHAR()
	ON_COMMAND(ID_FULL_SCREEN, OnFullScreen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScrntestView construction/destruction

CScrntestView::CScrntestView()
{
}

CScrntestView::~CScrntestView()
{
}

BOOL CScrntestView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CScrntestView diagnostics

#ifdef _DEBUG
void CScrntestView::AssertValid() const
{
	CView::AssertValid();
}

void CScrntestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CScrntestDoc* CScrntestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CScrntestDoc)));
	return (CScrntestDoc*)m_pDocument;
}
#endif //_DEBUG


#include "mainfrm.h"

void CScrntestView::OnDraw(CDC* pDC)
{
   bool use_fullscreen = ((CMainFrame*)(AfxGetApp()->m_pMainWnd))
                                          ->In_full_screen_mode();
   if (use_fullscreen)
      {
      CClientDC dc(NULL);
      OnPrepareDC(&dc);
      Draw_stuff(&dc, use_fullscreen);
      }
   else
      {
      Draw_stuff(pDC, use_fullscreen);
      }

   return;
}


void CScrntestView::Draw_stuff(CDC* pDC, bool use_fullscreen) const
{
   if (use_fullscreen)
      {
      int x = pDC->GetDeviceCaps(HORZRES);
      int y = pDC->GetDeviceCaps(VERTRES);

      pDC->SelectStockObject(BLACK_BRUSH);
      pDC->Rectangle(0, 0, x, y);

      char str[40];            // report client coordinates
      sprintf(str, "Resolution: %d x %d", x, y);
      pDC->TextOut(10, 50, str, strlen(str));

      pDC->SelectStockObject(WHITE_PEN);   // draw corner marks
      pDC->MoveTo(0, 0); pDC->LineTo(30, 0);
      pDC->MoveTo(0, 0); pDC->LineTo(0, 30);

      x--; y--;
      pDC->MoveTo(x, y); pDC->LineTo(x, y - 30);
      pDC->MoveTo(x, y); pDC->LineTo(x - 30, y);
      }
   else
      {
      pDC->TextOut(20, 20, "Normal mode", 11);
      }

   return;
}


void CScrntestView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
   if (nChar == VK_ESCAPE)
      {
      ((CMainFrame*)(AfxGetApp()->m_pMainWnd))
                                ->Restore_normal_screen_mode();
      }

   CView::OnChar(nChar, nRepCnt, nFlags);
}


void CScrntestView::OnFullScreen()
{
   ((CMainFrame*)(AfxGetApp()->m_pMainWnd))
                             ->Start_full_screen_mode();
   return;
}
